USES GUtils;

VAR
  Param: STRING;
  Arg  : Byte;


PROCEDURE SetVesaMode(Mode:Word); ASSEMBLER;
ASM
	MOV	AX, $4F00
	INT	10h
	CMP	AH, 0
	JNZ	@End
	MOV	AX, $4F02
	MOV	BX, Mode
	INT	10h
@End:
END;


PROCEDURE Instructions;
BEGIN
  Writeln;
  Writeln('SET MODE Version 1.1');
  Writeln('Copyright (C) 1996 by The GodFather');
  Writeln;
  Writeln('     Usage: SM option');
  Writeln;
  Writeln('                   8  ->  Load default 8x8 font');
  Writeln('                  14  ->  Load default 8x14 font');
  Writeln('                  16  ->  Load default 8x16 font');
  Writeln;
  Writeln('                  40  ->  Set 80x40 video mode');
  Writeln('                  25  ->  Set 80x25 video mode');
  Writeln('                  50  ->  Set 80x50 video mode (80x43 for EGA)');
  Writeln;
  Writeln('                 The next options work if you have a VESA 1.1 compatible SVGA');
  Writeln;
  Writeln('                  60  ->  Set 80x60 video mode');
  Writeln('                 125  ->  Set 132x25 video mode');
  Writeln('                 132  ->  Set 132x50 video mode');
  Writeln('                 160  ->  Set 132x60 video mode');
  Halt;
END;


PROCEDURE ChangeMode;
BEGIN
  Cursor(Off);
  PosCursor(1,1);
  FillScreen(1,1,MaxX,MaxY*2,$7,' ');
  CASE Arg OF
     8: Load8x8;
    14: Load8x14;
    16: Load8x16;
    40: SetVideoMode(0);
    80,
    25: SetVideoMode(3);
    43,
    50: BEGIN SetVideoMode(3); Load8x8; END;

    60: SetVESAMode($108);
   125: SetVESAMode($109);
   132: BEGIN SetVESAMode($10C); Load8x14 END;
   160: SetVESAMode($10C);

   254: SetCharWidth(EGAWidth);
   255: SetCharWidth(VGAWidth);
  END;
END;



BEGIN
  Param := ParamStr(1);
  Arg   := StrToInt(Param);
  IF Arg IN [8,14,16,25,80,40,43,50,60,125,132,160,254,255]
    THEN ChangeMode
    ELSE Instructions;
END.
